#ifndef __TRD_H_INCLUDED__
#define __TRD_H_INCLUDED__

#include "exception_t.h"

#define TRD_SIZE 655360

#ifdef __GNUC__
#pragma pack(push,1)
#else
#pragma pack(push)
#endif
#pragma pack(1)

struct trd_fname {
	BYTE name[8];
	BYTE ext;
};

struct trd_cat_entry {
	struct trd_fname filename;
	BYTE start_l;
	BYTE start_h;
	BYTE length_l;
	BYTE length_h;
	BYTE sectors;
	BYTE start_sector;
	BYTE start_track;
};
#pragma pack(pop)

#ifndef __TRD_H_SELF_INCLUDE

extern void trd_read_sectors(BYTE *trd, unsigned start_track, unsigned start_sector, unsigned sector_count, BYTE *output);

extern void trd_write_sectors(BYTE *trd, unsigned start_track, unsigned start_sector, unsigned sector_count, BYTE *data);

extern void trd_read(char *fname, BYTE *trd_buff);

extern void trd_write(char *fname, BYTE *trd_buff);

extern void trd_writefile(BYTE *trd, BYTE *bfile_buff, int num_bytes, struct trd_fname *fname);

extern void trd_deletefile(BYTE *trd, struct trd_cat_entry *file, int is_last_file);

extern int trd_fname_equal(struct trd_fname *fname1, struct trd_fname *fname2);

extern void trd_parse_fname(char *filename, char fname_ext_separator, char with_del_files, struct trd_fname *fname);

/*find catalogue entry for file. returns NULL if not found*/
extern struct trd_cat_entry *trd_find_cat_entry(BYTE *trd, struct trd_fname *fname, char with_del_files, int *is_last_file);

#endif

#endif
